﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace ParallelTasks
{
    class Program
    {
        static void Main(string[] args)
        {
            Stopwatch sw = new Stopwatch();
            sw.Start();

            #region Parallel.Invoke way

            Parallel.Invoke(DoLeft, DoRight);

            #endregion

            sw.Stop();
            Console.WriteLine(sw.Elapsed.TotalSeconds);
            sw.Reset();
            sw.Start();

            #region Task.Factory way

            var task1 = Task.Factory.StartNew(DoLeft);      //StartNew, 创建并启动System.Threading.Tasks.Task
            var task2 = Task.Factory.StartNew(DoRight);

            Task.WaitAll(task1, task2);

            #endregion

            sw.Stop();
            Console.WriteLine(sw.Elapsed.TotalSeconds);

            Console.Read();
        }
        
        public static void DoLeft()
        {
            Thread.Sleep(10000);
            Console.WriteLine(string.Concat(DateTime.Now.ToLongTimeString(), " DoLeft is running!"));
        }

        public static void DoRight()
        {
            Thread.Sleep(2000);
            Console.WriteLine(string.Concat(DateTime.Now.ToLongTimeString(), " DoRight is running!"));
        }
    }
}
